hdu 1300 Pearls【dp】

来源:互联网 发布:数据分析师薪酬待遇 编辑:程序博客网 时间:2024/05/23 02:06

Pearls

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2113    Accepted Submission(s): 1011


Problem Description
In Pearlania everybody is fond of pearls. One company, called The Royal Pearl, produces a lot of jewelry with pearls in it. The Royal Pearl has its name because it delivers to the royal family of Pearlania. But it also produces bracelets and necklaces for ordinary people. Of course the quality of the pearls for these people is much lower then the quality of pearls for the royal family. In Pearlania pearls are separated into 100 different quality classes. A quality class is identified by the price for one single pearl in that quality class. This price is unique for that quality class and the price is always higher then the price for a pearl in a lower quality class.

Every month the stock manager of The Royal Pearl prepares a list with the number of pearls needed in each quality class. The pearls are bought on the local pearl market. Each quality class has its own price per pearl, but for every complete deal in a certain quality class one has to pay an extra amount of money equal to ten pearls in that class. This is to prevent tourists from buying just one pearl.

Also The Royal Pearl is suffering from the slow-down of the global economy. Therefore the company needs to be more efficient. The CFO (chief financial officer) has discovered that he can sometimes save money by buying pearls in a higher quality class than is actually needed. No customer will blame The Royal Pearl for putting better pearls in the bracelets, as long as the prices remain the same.

For example 5 pearls are needed in the 10 Euro category and 100 pearls are needed in the 20 Euro category. That will normally cost: (5+10)*10 + (100+10)*20 = 2350 Euro.

Buying all 105 pearls in the 20 Euro category only costs: (5+100+10)*20 = 2300 Euro.

The problem is that it requires a lot of computing work before the CFO knows how many pearls can best be bought in a higher quality class. You are asked to help The Royal Pearl with a computer program.

Given a list with the number of pearls and the price per pearl in different quality classes, give the lowest possible price needed to buy everything on the list. Pearls can be bought in the requested, or in a higher quality class, but not in a lower one.
 

Input
The first line of the input contains the number of test cases. Each test case starts with a line containing the number of categories c (1 <= c <= 100). Then, c lines follow, each with two numbers ai and pi. The first of these numbers is the number of pearls ai needed in a class (1 <= ai <= 1000). The second number is the price per pearl pi in that class (1 <= pi <= 1000). The qualities of the classes (and so the prices) are given in ascending order. All numbers in the input are integers.
 

Output
For each test case a single line containing a single number: the lowest possible price needed to buy everything on the list.
 Sample Input
2
2
100 1
100 2
3
1 10
1 11
100 12
 


Sample Output
330
1344


题目大意:

珠宝店有100种不同质量的珍珠,质量越高价钱越高,为了促进销售,每买一种类型的珍珠,要在原来的基础上必须再买10个。这时一个CFO发现,这种条件下,有时买质量更好的反而更便宜。比如要买10元的珍珠5个,20元的珍珠100个,普通的买法需要(5+10)*10 + (100+10)*20 = 2350,但是如果只买105个价值20元的珍珠,只需要 (5+100+10)*20 = 2300。现在给定要买的珍珠的数量和对应价格,求最少花费

思路:
设dp【i】表示买第i种珍珠的最小花费,那么dp【i】可能有两种买法,一种是直接买need【i】+10的数量的这个珍珠,也可能是买从j到i的need【i】加和个数量的这个珍珠。

辣么:
dp【i】=min(dp【i-1】+(need【i】+10)*price【i】,min(j到i)dp【j】+(sum【i】-sum【j】+10)*price【i】);

AC代码:

#include<stdio.h>#include<string.h>#include<iostream>using namespace std;int need[10000];int p[10000];int sum[10000];int dp[10000];int main(){    int T_T;    scanf("%d",&T_T);    while(T_T--)    {        int n;        scanf("%d",&n);        memset(dp,0,sizeof(dp));        memset(sum,0,sizeof(sum));        for(int i=1;i<=n;i++)        {            scanf("%d%d",&need[i],&p[i]);            sum[i]=sum[i-1]+need[i];        }        for(int i=1;i<=n;i++)        {            dp[i]=dp[i-1]+(need[i]+10)*p[i];            int minn=0x1f1f1f1f;            for(int j=0;j<i;j++)            {                int tmp=dp[j]+(sum[i]-sum[j]+10)*p[i];                minn=min(tmp,minn);            }            dp[i]=min(minn,dp[i]);        }        printf("%d\n",dp[n]);    }}







0 0
原创粉丝点击